diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mpdu-aggregator.h ns-3.44/src/wifi/model/mpdu-aggregator.h
--- ns-3.43/src/wifi/model/mpdu-aggregator.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/mpdu-aggregator.h	2025-03-09 16:55:49.795372700 -0700
@@ -30,8 +30,8 @@
 class HtFrameExchangeManager;
 
 /**
- * \brief Aggregator used to construct A-MPDUs
- * \ingroup wifi
+ * @brief Aggregator used to construct A-MPDUs
+ * @ingroup wifi
  */
 class MpduAggregator : public Object
 {
@@ -42,8 +42,8 @@
     typedef std::map<AcIndex, Ptr<QosTxop>> EdcaQueues;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -53,16 +53,16 @@
     /**
      * Aggregate an MPDU to an A-MPDU.
      *
-     * \param mpdu the MPDU.
-     * \param ampdu the A-MPDU.
-     * \param isSingle whether it is a single MPDU.
+     * @param mpdu the MPDU.
+     * @param ampdu the A-MPDU.
+     * @param isSingle whether it is a single MPDU.
      */
     static void Aggregate(Ptr<const WifiMpdu> mpdu, Ptr<Packet> ampdu, bool isSingle);
 
     /**
      * Set the ID of the link this MPDU aggregator is associated with.
      *
-     * \param linkId the ID of the link this MPDU aggregator is associated with
+     * @param linkId the ID of the link this MPDU aggregator is associated with
      */
     void SetLinkId(uint8_t linkId);
 
@@ -70,9 +70,9 @@
      * Compute the size of the A-MPDU resulting from the aggregation of an MPDU of
      * size <i>mpduSize</i> and an A-MPDU of size <i>ampduSize</i>.
      *
-     * \param mpduSize the MPDU size in bytes.
-     * \param ampduSize the A-MPDU size in bytes.
-     * \return the size of the resulting A-MPDU in bytes.
+     * @param mpduSize the MPDU size in bytes.
+     * @param ampduSize the A-MPDU size in bytes.
+     * @return the size of the resulting A-MPDU in bytes.
      */
     static uint32_t GetSizeIfAggregated(uint32_t mpduSize, uint32_t ampduSize);
 
@@ -80,10 +80,10 @@
      * Determine the maximum size for an A-MPDU of the given TID that can be sent
      * to the given receiver when using the given modulation class.
      *
-     * \param recipient the receiver station address.
-     * \param tid the TID.
-     * \param modulation the modulation class.
-     * \return the maximum A-MPDU size in bytes.
+     * @param recipient the receiver station address.
+     * @param tid the TID.
+     * @param modulation the modulation class.
+     * @return the maximum A-MPDU size in bytes.
      */
     uint32_t GetMaxAmpduSize(Mac48Address recipient,
                              uint8_t tid,
@@ -115,10 +115,10 @@
      * established with the receiver, or another MPDU to aggregate was not found),
      * the returned vector is empty.
      *
-     * \param mpdu the given MPDU.
-     * \param txParams the TX parameters used to transmit the frame
-     * \param availableTime the time available for the frame exchange
-     * \return the resulting A-MPDU, if aggregation is possible.
+     * @param mpdu the given MPDU.
+     * @param txParams the TX parameters used to transmit the frame
+     * @param availableTime the time available for the frame exchange
+     * @return the resulting A-MPDU, if aggregation is possible.
      */
     std::vector<Ptr<WifiMpdu>> GetNextAmpdu(Ptr<WifiMpdu> mpdu,
                                             WifiTxParameters& txParams,
@@ -127,13 +127,13 @@
     /**
      * Set the MAC layer to use.
      *
-     * \param mac the MAC layer to use
+     * @param mac the MAC layer to use
      */
     void SetWifiMac(const Ptr<WifiMac> mac);
 
     /**
-     * \param ampduSize the size of the A-MPDU that needs to be padded in bytes
-     * \return the size of the padding that must be added to the end of an A-MPDU in bytes
+     * @param ampduSize the size of the A-MPDU that needs to be padded in bytes
+     * @return the size of the padding that must be added to the end of an A-MPDU in bytes
      *
      * Calculates how much padding must be added to the end of an A-MPDU of the given size
      * (once another MPDU is aggregated).
@@ -145,9 +145,9 @@
      * Get the A-MPDU subframe header corresponding to the MPDU size and
      * whether the MPDU is a single MPDU.
      *
-     * \param mpduSize size of the MPDU in bytes.
-     * \param isSingle true if S-MPDU.
-     * \return the A-MPDU subframe header
+     * @param mpduSize size of the MPDU in bytes.
+     * @param isSingle true if S-MPDU.
+     * @return the A-MPDU subframe header
      */
     static AmpduSubframeHeader GetAmpduSubframeHeader(uint16_t mpduSize, bool isSingle);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/msdu-aggregator.cc ns-3.44/src/wifi/model/msdu-aggregator.cc
--- ns-3.43/src/wifi/model/msdu-aggregator.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/msdu-aggregator.cc	2025-03-09 16:55:49.795372700 -0700
@@ -9,10 +9,11 @@
 
 #include "msdu-aggregator.h"
 
+#include "ap-wifi-mac.h"
+#include "gcr-manager.h"
 #include "qos-txop.h"
 #include "wifi-mac-queue.h"
 #include "wifi-mac-trailer.h"
-#include "wifi-mac.h"
 #include "wifi-remote-station-manager.h"
 #include "wifi-tx-parameters.h"
 
@@ -83,15 +84,12 @@
 {
     NS_LOG_FUNCTION(this << *peekedItem << &txParams << availableTime);
 
-    Ptr<WifiMacQueue> queue = m_mac->GetTxopQueue(peekedItem->GetQueueAc());
-
-    uint8_t tid = peekedItem->GetHeader().GetQosTid();
-    auto recipient = peekedItem->GetOriginal()->GetHeader().GetAddr1();
-
     /* "The Address 1 field of an MPDU carrying an A-MSDU shall be set to an
      * individual address or to the GCR concealment address" (Section 10.12
      * of 802.11-2016)
      */
+    const auto& header = peekedItem->GetOriginal()->GetHeader();
+    const auto recipient = GetIndividuallyAddressedRecipient(m_mac, header);
     NS_ABORT_MSG_IF(recipient.IsBroadcast(), "Recipient address is broadcast");
 
     /* "A STA shall not transmit an A-MSDU within a QoS Data frame under a block
@@ -106,14 +104,45 @@
 
     NS_ASSERT(m_htFem);
 
+    auto queue = m_mac->GetTxopQueue(peekedItem->GetQueueAc());
+
+    // if GCR, A-MSDU is always used with a single A-MSDU subframe
+    if (IsGcr(m_mac, header))
+    {
+        auto apMac = DynamicCast<ApWifiMac>(m_mac);
+        NS_ASSERT(apMac);
+        auto gcrManager = apMac->GetGcrManager();
+        if (!gcrManager->UseConcealment(peekedItem->GetHeader()))
+        {
+            return nullptr;
+        }
+        auto msdu = peekedItem->GetOriginal();
+        auto gcrAmsdu =
+            Create<WifiMpdu>(msdu->GetPacket(), msdu->GetHeader(), msdu->GetTimestamp());
+        gcrAmsdu->Aggregate(nullptr);
+        queue->Replace(msdu, gcrAmsdu);
+        if (msdu->GetHeader().IsRetry())
+        {
+            gcrAmsdu->AssignSeqNo(msdu->GetHeader().GetSequenceNumber());
+        }
+        return m_htFem->CreateAliasIfNeeded(gcrAmsdu);
+    }
+    else if (IsGroupcast(recipient))
+    {
+        NS_LOG_DEBUG("No A-MSDU aggregation for groupcast frames without GCR service");
+        return nullptr;
+    }
+
+    const auto tid = header.GetQosTid();
     if (GetMaxAmsduSize(recipient, tid, txParams.m_txVector.GetModulationClass()) == 0)
     {
         NS_LOG_DEBUG("A-MSDU aggregation disabled");
         return nullptr;
     }
 
-    Ptr<WifiMpdu> amsdu = queue->GetOriginal(peekedItem);
-    uint8_t nMsdu = 1;
+    // perform A-MSDU aggregation
+    auto amsdu = queue->GetOriginal(peekedItem);
+    std::size_t nMsdu = 1;
     peekedItem = queue->PeekByTidAndAddress(tid, recipient, peekedItem->GetOriginal());
 
     // stop aggregation if we find an A-MSDU in the queue. This likely happens when an A-MSDU is
@@ -127,7 +156,7 @@
                       "Found item with sequence number assignment after one without: perhaps "
                       "sequence numbers were not released correctly?");
         // find the next MPDU before dequeuing the current one
-        Ptr<const WifiMpdu> msdu = peekedItem->GetOriginal();
+        auto msdu = peekedItem->GetOriginal();
         peekedItem = queue->PeekByTidAndAddress(tid, recipient, msdu);
         queue->DequeueIfQueued({amsdu});
         // perform A-MSDU aggregation
@@ -167,7 +196,7 @@
 
     if (maxAmsduSize == 0)
     {
-        NS_LOG_DEBUG("A-MSDU Aggregation is disabled on this station for AC " << ac);
+        NS_LOG_DEBUG("A-MSDU Aggregation is disabled on this station for " << ac);
         return 0;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/msdu-aggregator.h ns-3.44/src/wifi/model/msdu-aggregator.h
--- ns-3.43/src/wifi/model/msdu-aggregator.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/msdu-aggregator.h	2025-03-09 16:55:49.795372700 -0700
@@ -29,8 +29,8 @@
 class WifiTxParameters;
 
 /**
- * \brief Aggregator used to construct A-MSDUs
- * \ingroup wifi
+ * @brief Aggregator used to construct A-MSDUs
+ * @ingroup wifi
  */
 class MsduAggregator : public Object
 {
@@ -39,8 +39,8 @@
     typedef std::map<AcIndex, Ptr<QosTxop>> EdcaQueues;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -50,7 +50,7 @@
     /**
      * Set the ID of the link this MSDU aggregator is associated with.
      *
-     * \param linkId the ID of the link this MSDU aggregator is associated with
+     * @param linkId the ID of the link this MSDU aggregator is associated with
      */
     void SetLinkId(uint8_t linkId);
 
@@ -60,9 +60,9 @@
      * Note that only the basic A-MSDU subframe format (section 9.3.2.2.2 of IEEE
      * 802.11-2016) is supported.
      *
-     * \param msduSize the MSDU size in bytes.
-     * \param amsduSize the A-MSDU size in bytes.
-     * \return the size of the resulting A-MSDU in bytes.
+     * @param msduSize the MSDU size in bytes.
+     * @param amsduSize the A-MSDU size in bytes.
+     * @return the size of the resulting A-MSDU in bytes.
      */
     static uint16_t GetSizeIfAggregated(uint16_t msduSize, uint16_t amsduSize);
 
@@ -91,10 +91,10 @@
      * A-MSDU is enqueued in the queue (replacing the given MPDU) and returned.
      * Otherwise, no MSDU is dequeued from the EDCA queue and a null pointer is returned.
      *
-     * \param peekedItem the MSDU which we attempt to aggregate other MSDUs to
-     * \param txParams the TX parameters for the current frame
-     * \param availableTime the time available for the frame exchange
-     * \return the resulting A-MSDU, if aggregation is possible, a null pointer otherwise.
+     * @param peekedItem the MSDU which we attempt to aggregate other MSDUs to
+     * @param txParams the TX parameters for the current frame
+     * @param availableTime the time available for the frame exchange
+     * @return the resulting A-MSDU, if aggregation is possible, a null pointer otherwise.
      */
     Ptr<WifiMpdu> GetNextAmsdu(Ptr<WifiMpdu> peekedItem,
                                WifiTxParameters& txParams,
@@ -104,10 +104,10 @@
      * Determine the maximum size for an A-MSDU of the given TID that can be sent
      * to the given receiver when using the given modulation class.
      *
-     * \param recipient the receiver station address.
-     * \param tid the TID.
-     * \param modulation the modulation class.
-     * \return the maximum A-MSDU size in bytes.
+     * @param recipient the receiver station address.
+     * @param tid the TID.
+     * @param modulation the modulation class.
+     * @return the maximum A-MSDU size in bytes.
      */
     uint16_t GetMaxAmsduSize(Mac48Address recipient,
                              uint8_t tid,
@@ -115,15 +115,15 @@
 
     /**
      *
-     * \param aggregatedPacket the aggregated packet.
-     * \returns DeaggregatedMsdus.
+     * @param aggregatedPacket the aggregated packet.
+     * @returns DeaggregatedMsdus.
      */
     static WifiMpdu::DeaggregatedMsdus Deaggregate(Ptr<Packet> aggregatedPacket);
 
     /**
      * Set the MAC layer to use.
      *
-     * \param mac the MAC layer to use
+     * @param mac the MAC layer to use
      */
     void SetWifiMac(const Ptr<WifiMac> mac);
 
@@ -132,9 +132,9 @@
      * given size if a new MSDU is added.
      * Each A-MSDU subframe is padded so that its length is multiple of 4 octets.
      *
-     * \param amsduSize the size of the A-MSDU
+     * @param amsduSize the size of the A-MSDU
      *
-     * \return the number of octets required for padding
+     * @return the number of octets required for padding
      */
     static uint8_t CalculatePadding(uint16_t amsduSize);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/nist-error-rate-model.h ns-3.44/src/wifi/model/nist-error-rate-model.h
--- ns-3.43/src/wifi/model/nist-error-rate-model.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/nist-error-rate-model.h	2025-03-09 16:55:49.795372700 -0700
@@ -16,7 +16,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * A model for the error rate for different modulations.  For OFDM modulation,
  * the model description and validation can be found in
@@ -27,8 +27,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -45,73 +45,73 @@
     /**
      * Return the bValue such that coding rate = bValue / (bValue + 1).
      *
-     * \param codeRate the coding rate
+     * @param codeRate the coding rate
      *
-     * \return the bValue such that coding rate = bValue / (bValue + 1)
+     * @return the bValue such that coding rate = bValue / (bValue + 1)
      */
     uint8_t GetBValue(WifiCodeRate codeRate) const;
     /**
      * Return the coded BER for the given p and b.
      *
-     * \param p the SNR ratio (in linear scale)
-     * \param bValue such that coding rate = bValue / (bValue + 1)
+     * @param p the SNR ratio (in linear scale)
+     * @param bValue such that coding rate = bValue / (bValue + 1)
      *
-     * \return the coded BER
+     * @return the coded BER
      */
     double CalculatePe(double p, uint8_t bValue) const;
     /**
      * Return BER of BPSK at the given SNR.
      *
-     * \param snr SNR ratio (in linear scale)
+     * @param snr SNR ratio (in linear scale)
      *
-     * \return BER of BPSK at the given SNR
+     * @return BER of BPSK at the given SNR
      */
     double GetBpskBer(double snr) const;
     /**
      * Return BER of QPSK at the given SNR.
      *
-     * \param snr SNR ratio (in linear scale)
+     * @param snr SNR ratio (in linear scale)
      *
-     * \return BER of QPSK at the given SNR
+     * @return BER of QPSK at the given SNR
      */
     double GetQpskBer(double snr) const;
     /**
      * Return BER of QAM for a given constellation size at the given SNR.
      *
-     * \param constellationSize the constellation size (M)
-     * \param snr SNR ratio (in linear scale)
-     * \return BER of QAM for a given constellation size at the given SNR
+     * @param constellationSize the constellation size (M)
+     * @param snr SNR ratio (in linear scale)
+     * @return BER of QAM for a given constellation size at the given SNR
      */
     double GetQamBer(uint16_t constellationSize, double snr) const;
     /**
      * Return BER of BPSK at the given SNR after applying FEC.
      *
-     * \param snr SNR ratio (in linear scale)
-     * \param nbits the number of bits in the chunk
-     * \param bValue the bValue such that coding rate = bValue / (bValue + 1)
+     * @param snr SNR ratio (in linear scale)
+     * @param nbits the number of bits in the chunk
+     * @param bValue the bValue such that coding rate = bValue / (bValue + 1)
      *
-     * \return BER of BPSK at the given SNR after applying FEC
+     * @return BER of BPSK at the given SNR after applying FEC
      */
     double GetFecBpskBer(double snr, uint64_t nbits, uint8_t bValue) const;
     /**
      * Return BER of QPSK at the given SNR after applying FEC.
      *
-     * \param snr SNR ratio (in linear scale)
-     * \param nbits the number of bits in the chunk
-     * \param bValue the bValue such that coding rate = bValue / (bValue + 1)
+     * @param snr SNR ratio (in linear scale)
+     * @param nbits the number of bits in the chunk
+     * @param bValue the bValue such that coding rate = bValue / (bValue + 1)
      *
-     * \return BER of QPSK at the given SNR after applying FEC
+     * @return BER of QPSK at the given SNR after applying FEC
      */
     double GetFecQpskBer(double snr, uint64_t nbits, uint8_t bValue) const;
     /**
      * Return BER of QAM for a given constellation size at the given SNR after applying FEC.
      *
-     * \param constellationSize the constellation size (M)
-     * \param snr SNR ratio (in linear scale)
-     * \param nbits the number of bits in the chunk
-     * \param bValue the bValue such that coding rate = bValue / (bValue + 1)
+     * @param constellationSize the constellation size (M)
+     * @param snr SNR ratio (in linear scale)
+     * @param nbits the number of bits in the chunk
+     * @param bValue the bValue such that coding rate = bValue / (bValue + 1)
      *
-     * \return BER of QAM for a given constellation size at the given SNR after applying FEC
+     * @return BER of QAM for a given constellation size at the given SNR after applying FEC
      */
     double GetFecQamBer(uint16_t constellationSize,
                         double snr,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/non-ht/dsss-error-rate-model.h ns-3.44/src/wifi/model/non-ht/dsss-error-rate-model.h
--- ns-3.43/src/wifi/model/non-ht/dsss-error-rate-model.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/non-ht/dsss-error-rate-model.h	2025-03-09 16:55:49.795372700 -0700
@@ -27,17 +27,17 @@
 /**
  * Integral function using GSL library
  *
- * \param x the input x variable
- * \param params a pointer to FunctionParameters struct
+ * @param x the input x variable
+ * @param params a pointer to FunctionParameters struct
  *
- * \return the integral function
+ * @return the integral function
  */
 double IntegralFunction(double x, void* params);
 #endif
 
 /**
- * \brief an implementation of DSSS error rate model
- * \ingroup wifi
+ * @brief an implementation of DSSS error rate model
+ * @ingroup wifi
  *
  * The 802.11b modulations:
  *    - 1 Mbps mode is based on DBPSK. BER is from equation 5.2-69 from John G. Proakis
@@ -64,47 +64,47 @@
     /**
      * A function DQPSK
      *
-     * \param x the input variable
+     * @param x the input variable
      *
-     * \return DQPSK (x)
+     * @return DQPSK (x)
      */
     static double DqpskFunction(double x);
     /**
      * Return the chunk success rate of the differential BPSK.
      *
-     * \param sinr the SINR ratio (not dB) of the chunk
-     * \param nbits the size of the chunk
+     * @param sinr the SINR ratio (not dB) of the chunk
+     * @param nbits the size of the chunk
      *
-     * \return the chunk success rate of the differential BPSK
+     * @return the chunk success rate of the differential BPSK
      */
     static double GetDsssDbpskSuccessRate(double sinr, uint64_t nbits);
     /**
      * Return the chunk success rate of the differential encoded QPSK.
      *
-     * \param sinr the SINR ratio (not dB) of the chunk
-     * \param nbits the size of the chunk
+     * @param sinr the SINR ratio (not dB) of the chunk
+     * @param nbits the size of the chunk
      *
-     * \return the chunk success rate of the differential encoded QPSK.
+     * @return the chunk success rate of the differential encoded QPSK.
      */
     static double GetDsssDqpskSuccessRate(double sinr, uint64_t nbits);
     /**
      * Return the chunk success rate of the differential encoded QPSK for
      * 5.5Mbps data rate.
      *
-     * \param sinr the SINR ratio (not dB) of the chunk
-     * \param nbits the size of the chunk
+     * @param sinr the SINR ratio (not dB) of the chunk
+     * @param nbits the size of the chunk
      *
-     * \return the chunk success rate of the differential encoded QPSK for
+     * @return the chunk success rate of the differential encoded QPSK for
      */
     static double GetDsssDqpskCck5_5SuccessRate(double sinr, uint64_t nbits);
     /**
      * Return the chunk success rate of the differential encoded QPSK for
      * 11Mbps data rate.
      *
-     * \param sinr the SINR ratio (not dB) of the chunk
-     * \param nbits the size of the chunk
+     * @param sinr the SINR ratio (not dB) of the chunk
+     * @param nbits the size of the chunk
      *
-     * \return the chunk success rate of the differential encoded QPSK for
+     * @return the chunk success rate of the differential encoded QPSK for
      */
     static double GetDsssDqpskCck11SuccessRate(double sinr, uint64_t nbits);
 #ifdef HAVE_GSL
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/non-ht/dsss-parameter-set.h ns-3.44/src/wifi/model/non-ht/dsss-parameter-set.h
--- ns-3.43/src/wifi/model/non-ht/dsss-parameter-set.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/non-ht/dsss-parameter-set.h	2025-03-09 16:55:49.795372700 -0700
@@ -15,8 +15,8 @@
 {
 
 /**
- * \brief The DSSS Parameter Set
- * \ingroup wifi
+ * @brief The DSSS Parameter Set
+ * @ingroup wifi
  *
  * This class knows how to serialise and deserialise the DSSS Parameter Set.
  */
@@ -31,7 +31,7 @@
     /**
      * Set the Current Channel field in the DsssParameterSet information element.
      *
-     * \param currentChannel the CurrentChannel field in the DsssParameterSet information element
+     * @param currentChannel the CurrentChannel field in the DsssParameterSet information element
      */
     void SetCurrentChannel(uint8_t currentChannel);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/non-ht/dsss-phy.cc ns-3.44/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.43/src/wifi/model/non-ht/dsss-phy.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/non-ht/dsss-phy.cc	2025-03-09 16:55:49.795372700 -0700
@@ -60,7 +60,7 @@
 /**
  * Get the array of possible DSSS rates.
  *
- * \return the DSSS rates in bits per second
+ * @return the DSSS rates in bits per second
  */
 const std::array<uint64_t, 4>&
 GetDsssRatesBpsList()
@@ -142,7 +142,7 @@
 DsssPhy::GetPreambleDuration(const WifiTxVector& txVector) const
 {
     if (txVector.GetPreambleType() == WIFI_PREAMBLE_SHORT &&
-        (txVector.GetMode().GetDataRate(22) > 1000000))
+        (txVector.GetMode().GetDataRate(MHz_u{22}) > 1000000))
     {
         // Section 16.2.2.3 "Short PPDU format" Figure 16-2 "Short PPDU format"; IEEE Std
         // 802.11-2016
@@ -159,7 +159,7 @@
 DsssPhy::GetHeaderDuration(const WifiTxVector& txVector) const
 {
     if (txVector.GetPreambleType() == WIFI_PREAMBLE_SHORT &&
-        (txVector.GetMode().GetDataRate(22) > 1000000))
+        (txVector.GetMode().GetDataRate(MHz_u{22}) > 1000000))
     {
         // Section 16.2.2.3 "Short PPDU format" and Figure 16-2 "Short PPDU format"; IEEE Std
         // 802.11-2016
@@ -183,7 +183,8 @@
                             double& /* totalAmpduNumSymbols */,
                             uint16_t /* staId */) const
 {
-    return MicroSeconds(lrint(ceil((size * 8.0) / (txVector.GetMode().GetDataRate(22) / 1.0e6))));
+    return MicroSeconds(
+        lrint(ceil((size * 8.0) / (txVector.GetMode().GetDataRate(MHz_u{22}) / 1.0e6))));
 }
 
 Ptr<WifiPpdu>
@@ -236,7 +237,7 @@
 MHz_u
 DsssPhy::GetRxChannelWidth(const WifiTxVector& txVector) const
 {
-    if (m_wifiPhy->GetChannelWidth() > 20)
+    if (m_wifiPhy->GetChannelWidth() > MHz_u{20})
     {
         /*
          * This is a workaround necessary with HE-capable PHYs,
@@ -244,7 +245,7 @@
          * Without this hack, SpectrumWifiPhy::GetBand will crash.
          * FIXME: see issue #402 for a better solution.
          */
-        return 20;
+        return MHz_u{20};
     }
     return PhyEntity::GetRxChannelWidth(txVector);
 }
@@ -252,7 +253,7 @@
 MHz_u
 DsssPhy::GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const
 {
-    return ppdu ? GetRxChannelWidth(ppdu->GetTxVector()) : 22;
+    return ppdu ? GetRxChannelWidth(ppdu->GetTxVector()) : MHz_u{22};
 }
 
 Ptr<SpectrumValue>
@@ -263,7 +264,7 @@
     const auto& txVector = ppdu->GetTxVector();
     const auto channelWidth = txVector.GetChannelWidth();
     NS_LOG_FUNCTION(this << centerFrequencies.front() << channelWidth << txPower);
-    NS_ABORT_MSG_IF(channelWidth != 22, "Invalid channel width for DSSS");
+    NS_ABORT_MSG_IF(channelWidth != MHz_u{22}, "Invalid channel width for DSSS");
     auto v =
         WifiSpectrumValueHelper::CreateDsssTxPowerSpectralDensity(centerFrequencies.front(),
                                                                   txPower,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/non-ht/dsss-phy.h ns-3.44/src/wifi/model/non-ht/dsss-phy.h
--- ns-3.43/src/wifi/model/non-ht/dsss-phy.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/non-ht/dsss-phy.h	2025-03-09 16:55:49.795372700 -0700
@@ -16,8 +16,8 @@
 #include <vector>
 
 /**
- * \file
- * \ingroup wifi
+ * @file
+ * @ingroup wifi
  * Declaration of ns3::DsssPhy class.
  */
 
@@ -25,8 +25,8 @@
 {
 
 /**
- * \brief PHY entity for HR/DSSS (11b)
- * \ingroup wifi
+ * @brief PHY entity for HR/DSSS (11b)
+ * @ingroup wifi
  *
  * Refer to IEEE 802.11-2016, clause 16 (HR/DSSS).
  * Note that DSSS rates (clause 15) are a subset
@@ -68,32 +68,32 @@
      * Return a WifiMode for HR/DSSS
      * corresponding to the provided rate.
      *
-     * \param rate the rate in bps
-     * \return a WifiMode for HR/DSSS
+     * @param rate the rate in bps
+     * @return a WifiMode for HR/DSSS
      */
     static WifiMode GetDsssRate(uint64_t rate);
     /**
      * Return a WifiMode for DSSS at 1 Mbps.
      *
-     * \return a WifiMode for DSSS at 1 Mbps
+     * @return a WifiMode for DSSS at 1 Mbps
      */
     static WifiMode GetDsssRate1Mbps();
     /**
      * Return a WifiMode for DSSS at 2 Mbps.
      *
-     * \return a WifiMode for DSSS at 2 Mbps
+     * @return a WifiMode for DSSS at 2 Mbps
      */
     static WifiMode GetDsssRate2Mbps();
     /**
      * Return a WifiMode for HR/DSSS at 5.5 Mbps.
      *
-     * \return a WifiMode for HR/DSSS at 5.5 Mbps
+     * @return a WifiMode for HR/DSSS at 5.5 Mbps
      */
     static WifiMode GetDsssRate5_5Mbps();
     /**
      * Return a WifiMode for HR/DSSS at 11 Mbps.
      *
-     * \return a WifiMode for HR/DSSS at 11 Mbps
+     * @return a WifiMode for HR/DSSS at 11 Mbps
      */
     static WifiMode GetDsssRate11Mbps();
 
@@ -102,8 +102,8 @@
      * name using ModulationLookupTable. This is mainly used as a
      * callback for WifiMode operation.
      *
-     * \param name the unique name of the DSSS or HR/DSSS mode
-     * \return WifiCodeRate corresponding to the unique name
+     * @param name the unique name of the DSSS or HR/DSSS mode
+     * @return WifiCodeRate corresponding to the unique name
      */
     static WifiCodeRate GetCodeRate(const std::string& name);
     /**
@@ -111,8 +111,8 @@
      * unique name using ModulationLookupTable. This is mainly used
      * as a callback for WifiMode operation.
      *
-     * \param name the unique name of the DSSS or HR/DSSS mode
-     * \return constellation size corresponding to the unique name
+     * @param name the unique name of the DSSS or HR/DSSS mode
+     * @return constellation size corresponding to the unique name
      */
     static uint16_t GetConstellationSize(const std::string& name);
     /**
@@ -121,9 +121,9 @@
      * This function is mainly used as a callback
      * for WifiMode operation.
      *
-     * \param txVector the TXVECTOR used for the transmission
-     * \param staId the station ID (only here to have a common signature for all callbacks)
-     * \return the data bit rate in bps.
+     * @param txVector the TXVECTOR used for the transmission
+     * @param staId the station ID (only here to have a common signature for all callbacks)
+     * @return the data bit rate in bps.
      */
     static uint64_t GetDataRateFromTxVector(const WifiTxVector& txVector, uint16_t staId);
     /**
@@ -131,19 +131,19 @@
      * the supplied parameters. This function is mainly used as a callback
      * for WifiMode operation.
      *
-     * \param name the unique name of the DSSS or HR/DSSS mode
-     * \param modClass the modulation class, must be either WIFI_MOD_CLASS_DSSS or
+     * @param name the unique name of the DSSS or HR/DSSS mode
+     * @param modClass the modulation class, must be either WIFI_MOD_CLASS_DSSS or
      * WIFI_MOD_CLASS_HR_DSSS
      *
-     * \return the data bit rate of this signal in bps.
+     * @return the data bit rate of this signal in bps.
      */
     static uint64_t GetDataRate(const std::string& name, WifiModulationClass modClass);
     /**
      * Check whether the combination in TXVECTOR is allowed.
      * This function is used as a callback for WifiMode operation.
      *
-     * \param txVector the TXVECTOR
-     * \returns true if this combination is allowed, false otherwise.
+     * @param txVector the TXVECTOR
+     * @returns true if this combination is allowed, false otherwise.
      */
     static bool IsAllowed(const WifiTxVector& txVector);
 
@@ -155,21 +155,21 @@
     MHz_u GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
 
     /**
-     * \param txVector the transmission parameters
-     * \return the WifiMode used for the PHY header field
+     * @param txVector the transmission parameters
+     * @return the WifiMode used for the PHY header field
      */
     WifiMode GetHeaderMode(const WifiTxVector& txVector) const;
 
     /**
-     * \param txVector the transmission parameters
-     * \return the duration of the PHY preamble field
+     * @param txVector the transmission parameters
+     * @return the duration of the PHY preamble field
      *
-     * \see WIFI_PPDU_FIELD_PREAMBLE
+     * @see WIFI_PPDU_FIELD_PREAMBLE
      */
     Time GetPreambleDuration(const WifiTxVector& txVector) const;
     /**
-     * \param txVector the transmission parameters
-     * \return the duration of the PHY header field
+     * @param txVector the transmission parameters
+     * @return the duration of the PHY header field
      */
     Time GetHeaderDuration(const WifiTxVector& txVector) const;
 
@@ -177,8 +177,8 @@
      * End receiving the header, perform DSSS-specific actions, and
      * provide the status of the reception.
      *
-     * \param event the event holding incoming PPDU's information
-     * \return status of the reception of the header
+     * @param event the event holding incoming PPDU's information
+     * @return status of the reception of the header
      */
     PhyFieldRxStatus EndReceiveHeader(Ptr<Event> event);
 
@@ -187,10 +187,10 @@
      * must already be contained inside ModulationLookupTable.
      * This method binds all the callbacks used by WifiMode.
      *
-     * \param uniqueName the unique name of the WifiMode
-     * \param modClass the modulation class of the WifiMode, must be either WIFI_MOD_CLASS_DSSS or
+     * @param uniqueName the unique name of the WifiMode
+     * @param modClass the modulation class of the WifiMode, must be either WIFI_MOD_CLASS_DSSS or
      * WIFI_MOD_CLASS_HR_DSSS
-     * \return the DSSS or HR/DSSS WifiMode
+     * @return the DSSS or HR/DSSS WifiMode
      */
     static WifiMode CreateDsssMode(std::string uniqueName, WifiModulationClass modClass);
 
